;------------------------------------------------------------------------------
; BASIC-Erweiterung fr JU+TE-Computer ES 2K/ES1688
;------------------------------------------------------------------------------

		cpu	z8601

		org	8000h
		assume RP:0C0h		; keine Optimierung !

reg_08		equ	8	; Hi Adr. ext. Prozedurliste
reg_09		equ	9	; Lo Adr. ext. Prozedurliste
reg_0F		equ	0Fh	; Flags

; DATA-Pointer
dataptr_hi	equ	7Ch
dataptr_lo	equ	7Dh


rp 		equ	0FDh	; Register pointer

gpr 		equ	0FEh	; General purpose register bzw. Stackpointer, Highteil

; ext. Routinen
getch		equ	815h
putch		equ	818h
; UP aus Tiny MPBASIC
expr		equ	4C7h
linum		equ	500h
relcmp		equ	141h
skip		equ	593h


; Switches
demoprocs	equ	0	; 0 - Demo-Prozeduren nicht anlegen

;-----------------------------------------------------------------------------
; PROC [variablenliste] = prozedurname [parameterliste]
; PROC [Y1,Y2,Y3,..,Ym] = prozedurname [X1,X2,X3,..,Xn]
;-----------------------------------------------------------------------------
; bei Prozeduraufruf gilt:
; Stack	SP+2m+2n	Ym-1			je 2 Byte Werte
;	..		Ym-2
;	..		..
;	SP+2n+4		Y2
;	SP+2n+2		Y1
;	SP+2n		(intern f. interpreter)
;	SP+2n-2		X1
;	..		..
;	SP+4		Xn-2
;	SP+2		Xn-1
;	SP		returnadr. zum interpreter
; die rechten Parameter Ym, Xn werden in Registern abgelegt
; out RR2 = Ym, in RR4 Xm
;-----------------------------------------------------------------------------

;-----------------------------------------------------------------------------
; Liste	der Prozeduren
;-----------------------------------------------------------------------------
; BASIC-Einbindung
; 1 PROC SETRR[8,%8000];REM Erweiterung einbinden
;-----------------------------------------------------------------------------

		if 1=0
		; alternativ Einbingung per UP, Aufruf mit CALL%8000
init:		ld	reg_08, hi(tab_prc)
		ld	reg_09, lo(tab_prc)
		ret
		endif


tab_prc:	db	3,"CLS"		; CLS			Bildschirm lschen
		dw	p_cls
		if demoprocs <> 0
		db	3,"LET"		; Y=LET[X]		Demofkt., y=x
		dw	f_let
		db	4,"LET3"	; [A,B,C]=LET3[D,E,F]	Demofkt., 3fach-Zuweisung
		dw	f_let3
		endif
		db	4,"PSET"	; PSET[X,Y]		Punkt zeichnen
		dw	p_pset
		db	4,"PRES"	; PRES[X,Y]		Punkt lschen
		dw	p_pres
		db	5,"PTEST"	; Z=PTEST[X,Y]		Punkt abfragen
		dw	f_ptest

		db	5,"INKEY"	; T=INKEY		aktuell gedrckte Taste
		dw	f_inkey
		db	2,"AT"		; AT[X,Y]		Cursor positionieren
		dw	p_at

		db	7,"RESTORE"	; RESTORE[Zeile]	Datenzeile festlegen
		dw	p_restore
		db	4,"READ"	; Y=READ		Daten aus REM-Zeilen lesen
		dw	f_read

		db	0FFh		; Listenende

;-----------------------------------------------------------------------------
; CLS			statt CALL %8DD
; keine Parameter
; 10 PROC CLS
;-----------------------------------------------------------------------------

p_cls:		ld	r5, #12	; cls
		call	putch
		ret

		if demoprocs <> 0

;-----------------------------------------------------------------------------
; Demo EQUAL-Fkt. Y := X
; nur je ein Ein- und Ausgabeparameter, keine Stackzugriffe ntig
; out RR2 = Y, in RR4 X
; 10 PROC [A]=LET[B];PRINT LET[A]; REM dasselbe wie LET A=B; PRINT B
;-----------------------------------------------------------------------------

f_let:		ld	R2, R4		; Y := X
		ld	R3, R5
		ret
;-----------------------------------------------------------------------------
; Beispiel 3 Ein- und Ausgabeparameter PROC [Y1,Y2,Y3] = para [X1,X2,X3]
; in  X1, X2 auf Stack, RR4 = X3
; out Y1, Y2 auf Stack, RR2 = Y3
;	SP			returnadr.
;	SP+2 			Parameter X2
;	SP+4 			Parameter X1
;	SP+6			(intern f. interpreter)
;	SP+8			Platz f. Ergebnisvariable Y1
;	SP+10			Platz f. Ergebnisvariable Y2
; Beim Ende muss der SP auf (intern f. interpreter) zeigen
;90O[A,B,C]=LET3[%111,%222,%333]
;-----------------------------------------------------------------------------

f_let3:		pop	R2		; RR2 Rckkehradresse zum Interpreter
		pop	R3
		pop	R6		; RR6 Adresse von X2
		pop	R7
		pop	R8		; RR8 Adresse von X1
		pop	R9
		;...
		ld	R10,gpr		; stack
		ld	R11,gpr+1
		push	R3		; Ret-Adr. wieder auf Stack
		push	R2
		incw	RR10		; (intern) bergehen
		incw	RR10
		lde	@RR10,R8	; Y1 := X1
		incw	RR10
		lde	@RR10,R9
		incw	RR10
		lde	@RR10,R6	; Y2 := X2
		incw	RR10
		lde	@RR10,R7
		ld	R2,R4		; Y3 := X3
		ld	R3,R5
		ret

		endif

;-----------------------------------------------------------------------------
; ES2K Grafik-Befehle
; nach grafiklib_fca0 (ohne Variablennutzung, andere Registernutzung)

; orig CALL %FCA0 : Bildpunkt (X,Y) setzen
; (0,0) links unten, x horizonzal, y vertikal (63,63) rechts oben
;-----------------------------------------------------------------------------

p_pset:		pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		;
		pop	R8
		pop	R9		;RR8=X, RR4=Y
		CALL    PADR
		COM     R8		;Bitmaske negieren
		AND     R9, R8		;Bit rcksetzen
PSET1:		LDE     @RR10, R9	;Byte rckschreiben
PSET2:		jp 	@RR6

; orig CALL %FCB0 : Bildpunkt (X,Y) lschen
p_pres:		pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		pop	R8
		pop	R9		;RR8=X, RR4=Y
		;
		CALL    PADR
		OR      R9, R8		;setze Bit
		JR      PSET1

; orig CALL %FCBB : Bildpunkt (X,Y) lesen
; ret 1 = gesetzt
f_PTEST:	pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		pop	R8
		pop	R9		;RR8=X, RR4=Y
		;
		CALL    PADR
		CLR     R2
		CLR     R3		;Z=0
		TM      R8, R9		;Bit testen
		JR      NZ, PSET2	;wenn schwarz
		INC     R3		;Z=1
		JR      PSET2		;wenn wei
	
;UP Adr. zu (X,Y) berechnen
;out: RR10=Adr, R9=Byte, R8=Bitmaske
PADR:		LD      R10, #0FFh	;%FFF8 Anfang unterste Zeile
		LD      R11, #0F8h
		
		;RR8=X, RR4=Y
		AND     R5, #3Fh	;0..63
		RL      R5
		RL      R5
		RLC     R5		;
		RLC     R4		;y*8 (8 byte/zeile)
		SUB     R11, R5		;zeilen zhlen nach oben
		SBC     R10, R4
		LD      R8, #1		;Bitmaske
		AND     R9, #3Fh	;0..63
		INC     R9
PADR1:		DEC     R9
		RR      R8		;Bitmaske rotieren
		TM      R9, #7
		JR      NZ, PADR1
		RL      R9		;*2
		SWAP    R9		;/16
		ADD     R11, R9		;finale Adr. (+x/8)
		LDE     R9, @RR10	;Byte holen
		RET

;-----------------------------------------------------------------------------
; AT[X,Y]			statt SETR[%5B,A]
; Cursor positionieren
; %5B: Bildschirmpointer 
; 31 = zeile (0..)3, spalte (0..)1
; 40 = zeile (0..)4, spalte (0..)0
;-----------------------------------------------------------------------------
p_at:		pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7

		pop	R8
		pop	R9		;RR8=X, RR4=Y

		add	r9,r9		;X*16
		add	r9,r9
		add	r9,r9
		add	r9,r9
		add	r9,r5		;+y

		ld	05Bh, r9

		jp	@RR6

;-----------------------------------------------------------------------------
; Y=INKEY
; ermittelt den ASCII der gerade bettigten Taste.
;-----------------------------------------------------------------------------

f_inkey:	clr	06Dh
		call	0C56h		; TAS dynamische Tastenabfrage mit %6D: ASCII und T-Bit
		clr	R2
		ld	R3,06Dh
		and	r3,#7Fh
		ret

;-----------------------------------------------------------------------------
; DATA-Befehle
; 10 REM 1,2,3			anstelle DATA
; 20 RESTORE[10]
; 30 Y=READ; PRINT Y
;-----------------------------------------------------------------------------

; suche passende zeile oder nchstgrere; bei Programmende -> Ende
; vgl. GOTO


p_restore:	push	r0		; aktuelle Position sichern
		push	r1
					; RR2 = ausdruck
		call	linum		; RR4 = aktuelle Zeilennummer
		call	relcmp		; vergleichen
		tm	reg_0F, #50h	; <=
		jr	NZ, p_restore3	; wenn ausdruck <= akt. Zeile

p_restore1:	; Suche vorwrts
		call	skip		; Rest bis Zeilenende bergehen
		incw	RR0
		ldc	R4, @RR0	; RR4 = nchste Zeilennummer
		incw	RR0
		ldc	R5, @RR0
		decw	RR0
		rl	R4		; Bit7 nach Cy und Bit0
		rcf			; Cy=0
		rrc	R4		; Bit7=0, Cy=orig. Bit7
		jr	NC, p_restore2	; Programmende erreicht?
		call	relcmp
		tm	reg_0F, #50h	; <=
		jr	Z, p_restore1	; weiter, solange ausdruck <= akt. Zeile
p_restore2:	; Programmende erreicht
		;decw	RR0
		jr	p_restore3a

p_restore3:	call	linum		; RR4 = aktuelle Zeilennummer
		jr	NC, p_restore4	; solange

		; Wenn Zeile gefunden
p_restore3a:	incw	RR0		; ZNr
		incw	RR0
		incw	RR0		; REM

		ld	dataptr_hi,R0
		ld	dataptr_lo,R1

		pop	r1
		pop	r0
		ret

p_restore4:	; suche Rckwrts
		call	relcmp
		tm	reg_0F, #60h	; >=
		jr	NZ, p_restore2
		decw	RR0		; ein Zeichen zurck
		jr	p_restore3		; weitersuchen


;-----------------------------------------------------------------------------
; READ, nchsten Wert aus DATA-Zeile (REM-Zeile) holen

f_read		push	r0		; aktuelle Position sichern
		push	r1
		ld	r0,dataptr_hi
		ld	r1,dataptr_lo
		call	expr
		incw	RR0		; ,
		ld	dataptr_hi,R0
		ld	dataptr_lo,R1
		pop	r1
		pop	r0
		ret

;-----------------------------------------------------------------------------

		end

