;------------------------------------------------------------------------------
; BASIC-Erweiterung fr JU+TE-Computer ES 4.0
; V.Pohlers 1.08.2021
;------------------------------------------------------------------------------

		cpu	z8601

		org	8000h
		assume RP:0C0h		; keine Optimierung !

reg_08		equ	8		; Hi Adr. ext. Prozedurliste
reg_09		equ	9		; Lo Adr. ext. Prozedurliste
reg_0F		equ	0Fh		; Flags

var_V_hi 	equ 	4Ah		; ...
var_V_lo 	equ 	4Bh		; ...
var_W_hi 	equ 	4Ch		; ...
var_W_lo 	equ 	4Dh		; ...
var_X_hi 	equ 	4Eh		; ...
var_X_lo 	equ 	4Fh		; ...
var_Y_hi 	equ 	50h		; ...
var_Y_lo 	equ 	51h		; ...
var_Z_hi 	equ 	52h		; ...
var_Z_lo 	equ 	53h		; ...
byte_5D		equ 	5Dh		; f. Circle

; DATA-Pointer
;dataptr_hi	equ	7Ch
;dataptr_lo	equ	7Dh

dataptr_hi	equ	54h		; frei in ES4.0
dataptr_lo	equ	6Eh		; frei in ES4.0

rp 		equ	0FDh		; Register pointer
gpr 		equ	0FEh		; General purpose register bzw. Stackpointer, Highteil

; ext. Routinen
getch		equ	815h
putch		equ	818h
; UP aus Tiny MPBASIC
expr		equ	4C7h
linum		equ	500h
relcmp		equ	141h
skip		equ	593h


; Switches
demoprocs	equ	0	; 0 - nicht anlegen


;-----------------------------------------------------------------------------
; PROC [variablenliste] = prozedurname [parameterliste]
; PROC [Y1,Y2,Y3,..,Ym] = prozedurname [X1,X2,X3,..,Xn]
;-----------------------------------------------------------------------------
; bei Prozeduraufruf gilt:
; Stack	SP+2m+2n	Ym-1			je 2 Byte Werte
;	..		Ym-2
;	..		..
;	SP+2n+4		Y2
;	SP+2n+2		Y1
;	SP+2n		(intern f. interpreter)
;	SP+2n-2		X1
;	..		..
;	SP+4		Xn-2
;	SP+2		Xn-1
;	SP		returnadr. zum interpreter
; die rechten Parameter Ym, Xn werden in Registern abgelegt
; out RR2 = Ym, in RR4 Xm
;-----------------------------------------------------------------------------


;-----------------------------------------------------------------------------
; Liste	der Prozeduren
;-----------------------------------------------------------------------------
; BASIC-Einbindung
; 1 PROC SETRR[8,%8000];REM Erweiterung einbinden
;-----------------------------------------------------------------------------

		if 1=0
		; alternativ Einbingung per UP, Aufruf mit CALL%8000
init:		ld	reg_08, hi(tab_prc)
		ld	reg_09, lo(tab_prc)
		ret
		endif


tab_prc:	db	3,"CLS"		; CLS			Bildschirm lschen
		dw	p_cls
		if demoprocs <> 0 
		db	3,"LET"		; Y=LET[X]		Demofkt., y=x
		dw	f_let
		db	4,"LET3"	; [A,B,C]=LET3[D,E,F]	Demofkt., 3fach-Zuweisung
		dw	f_let3
		endif
		db	4,"DRAW"	; DRAW[X1,Y1,X2,Y2,Farbe]	Linie
		dw	p_draw
		db	4,"PLOT"	; PLOT[X,Y,Farbe]	Punkt zeichnen
		dw	p_plot
		db	5,"PTEST"	; Farbe=PTEST[X,Y]	Farbe abfragen 
		dw	f_ptest
		db	6,"CIRCLE"	; CIRCLE[X,Y,Radius,Farbe]	Kreis
		dw	p_circle
		db	5,"COLOR"	; COLOR[FG,HG]		Farben setzen	statt OSETEB[%F7A0,%F0]
		dw	p_color
		db	5,"INKEY"	; T=INKEY		aktuell gedrckte Taste
		dw	f_inkey
		db	2,"AT"		; AT[X,Y]		Cursor positionieren
		dw	p_at
		db	7,"RESTORE"	; RESTORE[Zeile]	Datenzeile festlegen
		dw	p_restore
		db	4,"READ"	; Y=READ		Daten aus REM-Zeilen lesen
		dw	f_read

		db	0FFh		; Listenende

;-----------------------------------------------------------------------------
; CLS
; keine Parameter
; 10 PROC CLS
;-----------------------------------------------------------------------------

p_cls:		ld	r5, #12	; cls
		call	putch
		ret

		if demoprocs <> 0 

;-----------------------------------------------------------------------------
; Demo EQUAL-Fkt. Y := X
; nur je ein Ein- und Ausgabeparameter, keine Stackzugriffe ntig
; out RR2 = Y, in RR4 X
; 10 PROC [A]=LET[B];PRINT LET[A]; REM dasselbe wie LET A=B; PRINT B
;-----------------------------------------------------------------------------

f_let:		ld	R2, R4		; Y := X
		ld	R3, R5
		ret
;-----------------------------------------------------------------------------
; Beispiel 3 Ein- und Ausgabeparameter PROC [Y1,Y2,Y3] = para [X1,X2,X3]
; in  X1, X2 auf Stack, RR4 = X3 
; out Y1, Y2 auf Stack, RR2 = Y3 
;	SP			returnadr. 
;	SP+2 			Parameter X2
;	SP+4 			Parameter X1
;	SP+6			(intern f. interpreter)
;	SP+8			Platz f. Ergebnisvariable Y1
;	SP+10			Platz f. Ergebnisvariable Y2
; Beim Ende muss der SP auf (intern f. interpreter) zeigen
;90O[A,B,C]=LET3[%111,%222,%333]
;-----------------------------------------------------------------------------

f_let3:		pop	R2		; RR2 Rckkehradresse zum Interpreter
		pop	R3
		pop	R6		; RR6 Adresse von X2
		pop	R7
		pop	R8		; RR8 Adresse von X1
		pop	R9
		;...
		ld	R10,gpr		; stack 
		ld	R11,gpr+1
		push	R3		; Ret-Adr. wieder auf Stack
		push	R2
		incw	RR10		; (intern) bergehen
		incw	RR10
		lde	@RR10,R8	; Y1 := X1
		incw	RR10
		lde	@RR10,R9
		incw	RR10
		lde	@RR10,R6	; Y2 := X2
		incw	RR10
		lde	@RR10,R7
		ld	R2,R4		; Y3 := X3
		ld	R3,R5
		ret

		endif

;-----------------------------------------------------------------------------
; ES4.0 Grafik-Befehle
;
; PROC PLOT[X,Y,farbe]		Punkt setzen
; F=PTEST[X,Y]			Punkt abfragen
; PROC DRAW[X1,Y1,X2,Y2,farbe]	Linie von X1,Y1 nach X2,Y2
;
; Achtung: es werden intern die Variablen X,Y,Z und V,W (draw)  genutzt!


; PROC PLOT[X,Y,farbe]		Punkt setzen
p_plot:		pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		;	
		ld	var_Z_hi, R4	; Z:= Farbe
		ld	var_Z_lo, R5
		pop	R4		; Y
		pop	R5
		ld	var_Y_hi, R4
		ld	var_Y_lo, R5
		pop	R4		; X
		pop	R5
		ld	var_X_hi, R4
		ld	var_X_lo, R5

		
		call	017FDh 		; PLOT

		jp 	@RR6		; ret

; F=PTEST[X,Y]			Punkt abfragen
f_ptest:	pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		
		ld	var_Y_hi, R4	; Y
		ld	var_Y_lo, R5
		pop	R4		; X
		pop	R5
		ld	var_X_hi, R4
		ld	var_X_lo, R5

		call	017FAh 		; PTEST
		
		ld	R2,var_Z_hi	; Rckgabewert
		ld	R3,var_Z_lo

		jp 	@RR6		; ret

; PROC DRAW[X1,Y1,X2,Y2,farbe]	Linie von X1,Y1 nach X2,Y2
p_draw		pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		
		ld	var_Z_hi, R4	; Farbe
		ld	var_Z_lo, R5
		pop	R4		; Y2
		pop	R5
		ld	var_Y_hi, R4
		ld	var_Y_lo, R5
		pop	R4		; X2
		pop	R5
		ld	var_X_hi, R4
		ld	var_X_lo, R5
		pop	R4		; Y1
		pop	R5
		ld	var_W_hi, R4
		ld	var_W_lo, R5
		pop	R4		; X1
		pop	R5
		ld	var_V_hi, R4
		ld	var_V_lo, R5

		call	017F7h 		; DRAW

		jp 	@RR6

;-----------------------------------------------------------------------------
; CIRCLE[X,Y,Radius,Farbe]
; X,Y - Mittelpunkt Z -Farbe, V-Radius
; Mittelpunkt-Algorithmus
; Rolf Weidlich
;------------------------------------------------------------------------------

p_CIRCLE:	pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		
		ld	var_Z_hi, R4	; Farbe
		ld	var_Z_lo, R5
		pop	R4		; Radius
		pop	R5
		ld	var_V_hi, R4
		ld	var_V_lo, R5
		pop	R4		; Y
		pop	R5
		ld	var_Y_hi, R4
		ld	var_Y_lo, R5
		pop	R4		; X
		pop	R5
		ld	var_X_hi, R4
		ld	var_X_lo, R5

		push	R7
		push	R6

		srp	#70h
		ld	R4, var_X_hi
		ld	R5, var_X_lo
		ld	R6, var_Y_lo
		ld	R0, var_V_lo	; R0=x=r
		clr	R1		; R1=y=0
		ld	byte_5D, var_V_lo ; e=r
		call	circpx		; Pixel	frben

circl1:		ld	R3, R1		; R3=y
		rl	R3		; R3=2y
		inc	R3		; R3=2y+1
		inc	R1		; y=y+1
		sub	byte_5D, R3	; e=e-2y+1
		jr	NC, circl2	; wenn e>=0
		ld	R2, R0		; R2=x
		rl	R2		; R2=2x
		dec	R2		; R2=2x-1
		dec	R0		; x=x-1
		add	byte_5D, R2	; e=e+2x-1
circl2:		call	circpx		; Pixel	frben
		cp	R1, R0
		jp	C, circl1	; solange y < x
		ret

; Pixel	R5,R6 sowie symmetrische Pixel einfrben

circpx:		ld	var_X_lo, R5
		ld	var_X_hi, R4
		add	var_X_lo, R0
		adc	var_X_hi, #0
		ld	var_Y_lo, R6
		add	var_Y_lo, R1
		jr	NC, circpx1
		ld	var_Y_lo, #0C0h
circpx1:	call	PLOT1		; re.u.
		
		ld	var_X_lo, R5
		ld	var_X_hi, R4
		sub	var_X_lo, R0
		sbc	var_X_hi, #0
		ld	var_Y_lo, R6
		add	var_Y_lo, R1
		jr	NC, circpx2
		ld	var_Y_lo, #0C0h
circpx2:	call	PLOT1		; li.u.
		
		ld	var_X_lo, R5
		ld	var_X_hi, R4
		sub	var_X_lo, R0
		sbc	var_X_hi, #0
		ld	var_Y_lo, R6
		sub	var_Y_lo, R1
		jr	NC, circpx3
		ld	var_Y_lo, #0C0h
circpx3:	call	PLOT1		; li.o.

		ld	var_X_lo, R5
		ld	var_X_hi, R4
		add	var_X_lo, R0
		adc	var_X_hi, #0
		ld	var_Y_lo, R6
		sub	var_Y_lo, R1
		jr	NC, circpx4
		ld	var_Y_lo, #0C0h
circpx4:	call	PLOT1		; re.o.

		ld	var_X_lo, R5
		ld	var_X_hi, R4
		add	var_X_lo, R1
		adc	var_X_hi, #0
		ld	var_Y_lo, R6
		add	var_Y_lo, R0
		jr	NC, circpx5
		ld	var_Y_lo, #0C0h
circpx5:	call	PLOT1		; u.re.

		ld	var_X_lo, R5
		ld	var_X_hi, R4
		sub	var_X_lo, R1
		sbc	var_X_hi, #0
		ld	var_Y_lo, R6
		add	var_Y_lo, R0
		jr	NC, circpx6
		ld	var_Y_lo, #0C0h
circpx6:	call	PLOT1		; u.li.

		ld	var_X_lo, R5
		ld	var_X_hi, R4
		sub	var_X_lo, R1
		sbc	var_X_hi, #0
		ld	var_Y_lo, R6
		sub	var_Y_lo, R0
		jr	NC, circpx7
		ld	var_Y_lo, #0C0h
circpx7:	call	PLOT1		; o.li.

		ld	var_X_lo, R5
		ld	var_X_hi, R4
		add	var_X_lo, R1
		adc	var_X_hi, #0
		ld	var_Y_lo, R6
		sub	var_Y_lo, R0
		jr	NC, circpx8
		ld	var_Y_lo, #0C0h
circpx8:	call	PLOT1		; o.re.
		ret

; Hilfsroutine, spart ein paar Byte
PLOT1:		call	17FDh		; PLOT
		clr	var_X_hi	; X_hi = 0
		ret

;-----------------------------------------------------------------------------
; Y=INKEY
; ermittelt den ASCII der gerade bettigten Taste.
;-----------------------------------------------------------------------------

f_inkey:	call	081Bh		; KEY
		clr	R2
		ld	R3,06Dh
		ret

;-----------------------------------------------------------------------------
; AT[X,Y]
; Cursor positionieren
;-----------------------------------------------------------------------------

p_at:		pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		
		ld	var_Y_hi, R4	; Y
		ld	var_Y_lo, R5
		pop	R4		; X
		pop	R5
		ld	var_X_hi, R4
		ld	var_X_lo, R5

		clr	var_Z_hi
		ld	var_Z_lo, #1	; %01 setzt den	Textkursor
		call	827h		; SCRFUN
		
		jp 	@RR6		; ret

;-----------------------------------------------------------------------------
; COLOR[FG,HG]
; Farben setzen
;2D	gelb auf blau
;1D	dunkelgelb auf blau
;-----------------------------------------------------------------------------

p_color:	pop	R6		; RR6 Rckkehradresse zum Interpreter
		pop	R7
		
		pop	R2		; Hi-Byte verwerfen
		pop	R3		; FG
		add	R3,R3
		add	R3,R3
		add	R3,R3
		add	R3,R3		;FG*16
		add	R3,R5		;+HG		
		
		LD      R0,#0F7h	; Bitmaske fr Textzeichen
		LD      R1,#0A0h	
		LDE     @RR0,R3     	; neue Farbe
		jp	@RR6

;-----------------------------------------------------------------------------
; DATA-Befehle
; 10 REM 1,2,3			anstelle DATA
; 20 RESTORE[10]
; 30 Y=READ; PRINT Y
;-----------------------------------------------------------------------------

; suche passende zeile oder nchstgrere
; vgl. GOTO

p_restore:	push	r0		; aktuelle Position sichern
		push	r1
					; RR2 = ausdruck
		call	linum		; RR4 = aktuelle Zeilennummer 
		call	relcmp		; vergleichen
		tm	reg_0F, #50h	; <=
		jr	NZ, p_restore3	; wenn ausdruck <= akt. Zeile

p_restore1:	; Suche vorwrts
		call	skip		; Rest bis Zeilenende bergehen
		incw	RR0
		ldc	R4, @RR0	; RR4 = nchste Zeilennummer
		incw	RR0
		ldc	R5, @RR0
		decw	RR0
		rl	R4		; Bit7 nach Cy und Bit	0
		rcf			; Cy=0
		rrc	R4		; Bit7=0, Cy=orig. Bit7
		jr	NC, p_restore2	; Programmende erreicht?
		call	relcmp
		tm	reg_0F, #50h	; <=
		jr	Z, p_restore1	; weiter, solange ausdruck <= akt. Zeile
p_restore2:	; Programmende erreicht
		;decw	RR0
		jr	p_restore3a

p_restore3:	call	linum		; RR4 = aktuelle Zeilennummer 
		jr	NC, p_restore4	; solange 
		
		; Wenn Zeile gefunden
p_restore3a:	incw	RR0		; ZNr
		incw	RR0	
		incw	RR0		; REM
		
		ld	dataptr_hi,R0
		ld	dataptr_lo,R1
		
		pop	r1
		pop	r0
		ret

p_restore4:	; suche Rckwrts
		call	relcmp
		tm	reg_0F, #60h	; >=
		jr	NZ, p_restore2
		decw	RR0		; ein Zeichen zurck
		jr	p_restore3		; weitersuchen


;-----------------------------------------------------------------------------
; READ, nchsten Wert aus DATA-Zeile (REM-Zeile) holen

f_read		push	r0		; aktuelle Position sichern
		push	r1
		ld	r0,dataptr_hi
		ld	r1,dataptr_lo
		call	expr
		incw	RR0		; ,
		ld	dataptr_hi,R0
		ld	dataptr_lo,R1
		pop	r1
		pop	r0
		ret

;-----------------------------------------------------------------------------

		end

